angular.module('starter.controllers')

    .controller('baseBookDetailCtrl', function ($scope, $state, $ionicSlideBoxDelegate, apiService,uiService, $ionicLoading, ngCordovaService, bookService, broadcastService, broadcastConstants) {


        // ----------------------------------------------------------------------------------------------------------------
        $scope.tabNames = ['简介', '评论'];
        $scope.slectIndex = 0;
        $scope.activeSlide = function (index) {//点击时候触发
            $scope.slectIndex = index;
            $ionicSlideBoxDelegate.slide(index);
        };
        $scope.slideChanged = function (index) {//滑动时候触发
            $scope.slectIndex = index;
        };
        $scope.pages = ["modules/home/home_book_brifintro.html", "modules/home/home_book_comments.html"];

        /*
         * 图书相关信息：是否推荐、是否收藏
         */
        //
        // $scope.bookConcern = {
        //     userId: undefined,
        //     isbn: undefined,
        //     favoriteId: undefined,
        //     myFavorite: undefined,
        //     bookChoosingId: undefined,
        //     myBookChoosing: undefined,
        // };
        $scope.bookConcern = undefined;
        $scope.isbn = undefined;


        // ----------------------------------------------------------------------------------------------------------------
        // book concern
        $scope.isQueringBookConcern = false;
        $scope.queryBookConcern = function (isbn) {
            if (!$scope.user) {
                return;
            }
            $scope.isQueringBookConcern = true;
            var userId = $scope.user.account;
            apiService.queryBookConcern(userId, isbn, queryBookConcernCallback);
        };
        var queryBookConcernCallback = {
            onSuccess: function onLoginSuccess(data, status, config, headers) {
                console.log('queryBookConcern. onSuccess. data = ' + angular.toJson(data));
                $scope.bookConcern = data;
            },
            onError: function (data, status, hedaers, config) {
            },
            onFinally: function () {
                $scope.isQueringBookConcern = false;
            }
        };


        // ----------------------------------------------------------------------------------------------------------------
        // favorite: add
        $scope.isAddingFavorite = false;
        $scope.addFavorite = function (isbn) {
            if ($scope.isAddingFavorite || $scope.isRemovingFavorite) {
                return;
            }
            if (!$scope.user) {
                ngCordovaService.showToast('请先登录');
                return;
            }
            $scope.isAddingFavorite = true;
            uiService.ionicLoadingShow({ templateTitle: '正在收藏...' });//wsc-change 显示缓冲条
            var favorite = { userId: $scope.user.account, isbn: isbn };
            apiService.addFavorite(favorite, addFavoriteCallback);
        };
        var addFavoriteCallback = {
            onSuccess: function (data, status, config, headers) {
                console.log('收藏成功');
                ngCordovaService.showToast('收藏成功');
                var favorite = data;
                $scope.bookConcern.favoriteId = favorite.id;
                $scope.bookConcern.myFavorite = true;
            },
            onError: function (data, status, config, headers) {
                ngCordovaService.showToast('收藏失败');
            },
            onFinally: function () {
                $scope.isAddingFavorite = false;
                $ionicLoading.hide();//wsc-change 取消缓冲条
            }
        };
        // favorite: remove
        $scope.isRemovingFavorite = false;
        $scope.removeFavorite = function () {
            if ($scope.isAddingFavorite || $scope.isRemovingFavorite) {
                return;
            }
            if (!$scope.user) {
                ngCordovaService.showToast('请先登录');
                return;
            }
            if ($scope.bookConcern && $scope.bookConcern.favoriteId) {
                $scope.isRemovingFavorite = true;
                uiService.ionicLoadingShow({ templateTitle: '正在取消收藏...' });//wsc-change 显示缓冲条
                apiService.removeFavoriteById($scope.bookConcern.favoriteId, removeFavoriteCallback);
            }
        };
        var removeFavoriteCallback = {
            onSuccess: function (data, status, config, headers) {
                console.log('取消收藏成功');
                ngCordovaService.showToast('取消收藏成功');
                $scope.bookConcern.favoriteId = undefined;
                $scope.bookConcern.myFavorite = false;
            },
            onError: function (data, status, config, headers) {
                console.log('取消收藏失败');
                ngCordovaService.showToast('取消收藏失败');
            },
            onFinally: function () {
                $scope.isRemovingFavorite = false;
                $ionicLoading.hide();//wsc-change 取消缓冲条
            }
        };
        // toggle favorite
        $scope.toggleFavorite = function () {
            if ($scope.bookConcern) {
                if ($scope.bookConcern.myFavorite) {
                    $scope.removeFavorite();
                } else {
                    if ($scope.isbn) {
                        $scope.addFavorite($scope.isbn);
                    }
                }
            }
        }

        // ----------------------------------------------------------------------------------------------------------------
        // BookChoosing: new
        var isNewingBookChoosing = false;
        $scope.newBookChoosing = function (isbn) {
            if ($scope.isNewingBookChoosing || $scope.isDeletingBookChoosing) {
                return;
            }
            if (!$scope.user) {
                ngCordovaService.showToast('请先登录');
                return;
            }
            var bookChoosing = {
                userId: $scope.user.account,
                isbn: isbn,
            };
            $scope.isNewingBookChoosing = true;
            uiService.ionicLoadingShow({ templateTitle: '正在推荐...' });//wsc-change 显示缓冲条
            apiService.newBookChoosing(bookChoosing, newBookChoosingCallback);
        };
        var newBookChoosingCallback = {
            onSuccess: function (data, status, config, headers) {
                console.log('推荐成功');
                ngCordovaService.showToast('推荐成功');
                var bookChoosing = data;
                $scope.bookConcern.bookChoosingId = bookChoosing.id;
                $scope.bookConcern.myBookChoosing = true;
                if ($scope.bookConcern.isbn) {
                    $scope.queryBookChoosingCount($scope.isbn);
                }
                /****************wsc-change*****************/
                //发送广播
                broadcastService.send(
                    broadcastConstants.names.onDeleteBookChoosingChanged,
                    {
                        operation: 'newBookChoosing',
                        result: 'success',
                        isbn: $scope.isbn,
                    }
                );
            },
            onError: function (data, status, config, headers) {
                ngCordovaService.showToast('推荐失败');
            },
            onFinally: function () {
                $scope.isNewingBookChoosing = false;
                $ionicLoading.hide();//wsc-change 取消缓冲条
            }
        };
        // BookChoosing: delete
        $scope.isDeletingBookChoosing = false;
        $scope.deleteBookChoosing = function () {
            if ($scope.isNewingBookChoosing || $scope.isDeletingBookChoosing) {
                return;
            }
            if (!$scope.user) {
                console.warn('推荐. 请先登录');
                ngCordovaService.showToast('请先登录');
                return;
            }
            if ($scope.bookConcern && $scope.bookConcern.bookChoosingId) {
                $scope.isDeletingBookChoosing = true;
                uiService.ionicLoadingShow({ templateTitle: '正在推荐...' });//wsc-change 显示缓冲条
                apiService.deleteBookChoosing($scope.bookConcern.bookChoosingId, deleteBookChoosingCallback);
            }

        };
        var deleteBookChoosingCallback = {
            onSuccess: function (data, status, config, headers) {
                console.log('取消推荐成功');
                ngCordovaService.showToast('取消推荐成功');
                $scope.bookConcern.bookChoosingId = undefined;
                $scope.bookConcern.myBookChoosing = false;
                if ($scope.bookConcern.isbn) {
                    $scope.queryBookChoosingCount($scope.isbn);
                }
                /****************wsc-change*****************/
                //发送广播
                broadcastService.send(
                    broadcastConstants.names.onDeleteBookChoosingChanged,
                    {
                        operation: 'deleteBookChoosing',
                        result: 'success',
                        isbn: $scope.isbn,
                    }
                );
            },
            onError: function (data, status, config, headers) {
                console.log('取消推荐失败');
                ngCordovaService.showToast('取消推荐失败');
            },
            onFinally: function () {
                $scope.isDeletingBookChoosing = false;
                $ionicLoading.hide();//wsc-change 取消缓冲条
            }
        };
        // toggle book choosing
        $scope.toggleBookChoosing = function () {
            if ($scope.bookConcern) {
                if ($scope.bookConcern.myBookChoosing) {
                    $scope.deleteBookChoosing();
                } else {
                    if ($scope.isbn) {
                        $scope.newBookChoosing($scope.isbn);
                    }
                }
            }
        }
        // 查询某本书被推荐的次数
        $scope.bookChoosingCount = 0;
        $scope.queryBookChoosingCount = function (isbn) {
            apiService.queryBookChoosingCount(isbn, queryBookChoosingCountCallback);
        };
        var queryBookChoosingCountCallback = {
            onSuccess: function (data, status, config, headers) {
                console.log('获取图书推荐次数成功');
                $scope.bookChoosingCount = data;
            },
            onError: function (data, status, config, headers) {
                console.warn('获取图书推荐次数失败');
            }
        };





        // ----------------------------------------------------------------------------------------------------------------
        // SocialSharing
        $scope.socialShare = function (title, isbn) {
            ngCordovaService.socialShare(title, title, null, bookService.getBookSharingUrl(isbn), socialShareCallback);
        };
        var socialShareCallback = {
            onSuccess: function (data, status, config, headers) {
                console.log('socialShare. success');
            },
            onError: function (data, status, config, headers) {
                console.log('socialShare. error. data is ' + data);
            }

        };


        // ----------------------------------------------------------------------------------------------------------------
        // comments
        $scope.comments = [];                                       // 图书评论
        $scope.isGettingCommentsFromDoban = false;
        $scope.getCommentsFromDoban = function (isbn) {
            $scope.isGettingCommentsFromDoban = true;
            apiService.getCommentsFromDoban(isbn, getCommentsFromDobanCallback);
        };
        var getCommentsFromDobanCallback = {
            onSuccess: function (data, status, config, headers) {
                $scope.comments = data;
            },
            onError: function (data, status, config, headers) {
            },
            onFinally: function () {
                $scope.isGettingCommentsFromDoban = false;
            }
        };


        // ----------------------------------------------------------------------------------------------------------------
        // init 
        $scope.init = function (isbn) {
            if (isbn) {
                $scope.isbn = isbn.replace(/-/g, ''); // 去掉ISBN中的“-”
                $scope.queryBookConcern($scope.isbn);
                $scope.queryBookChoosingCount($scope.isbn);
                $scope.getCommentsFromDoban($scope.isbn);
            }
        };

    });