angular.module('starter.controllers')

    .controller('createActivityCtrl', function ($scope, $state, $ionicPopup, $ionicLoading, apiService, uiService, $ionicTabsDelegate, $ionicHistory, broadcastService, broadcastConstants) {

        $scope.activity = {
            organizerId: $scope.user.account,
            organizerName: $scope.user.name,
            startTime: new Date(),
            endTime: new Date()
        };

        $scope.createActivity = function () {
            var startTime = new Date($scope.activity.startTime).getTime();
            var endTime = new Date($scope.activity.endTime).getTime();
            var now = new Date();
            // now.setHours(0);
            // now.setMinutes(0);
            now.setSeconds(0);
            now.setMilliseconds(0);
            if (startTime > endTime) {
                $ionicPopup.alert(
                    {
                        title: '结束时间应该大于开始时间',
                        okText: '确定'
                    }
                );
            } else {
                uiService.ionicLoadingShow({ templateTitle: '正在创建活动...' });
                // 日期类型转换
                $scope.activity.startTime = new Date($scope.activity.startTime).getTime();
                $scope.activity.endTime = new Date($scope.activity.endTime).getTime();
                //
                $scope.activity.publishRole = '1'; // 角色：1表示APP用户 
                //
                apiService.createActivity($scope.activity, createActivityCallback);
            }
        }
        var createActivityCallback = {
            onSuccess: function (data, status, config, headers) {
                $ionicPopup.alert(
                    {
                        title: '创建活动',
                        template: '成功',
                        okText: '确定'
                    }
                ).then(function () {
                    /***************wsc-change********************/
                    // broadcast
                    broadcastService.send(
                        broadcastConstants.names.onActivityChanged,
                        {
                            operation: 'createActivity',
                            result: 'success',
                            activity: $scope.activity,
                        }
                    );
                    $ionicHistory.goBack();
                });
            },
            onError: function (data, status, config, headers) {
                $ionicPopup.alert(
                    {
                        title: '创建活动',
                        template: '失败',
                        okText: '确定'
                    }
                );
            },
            onFinally: function () {
                $ionicLoading.hide();
            }
        }
        $ionicTabsDelegate.showBar(false);
    });