angular.module('starter.controllers')

    .controller('patchActivityCtrl', function ($scope, $stateParams, $state, $ionicPopup, $ionicLoading, apiService, uiService, $ionicTabsDelegate, $ionicHistory, broadcastService, broadcastConstants) {
        $scope.id = $stateParams.id;
        $scope.activity = $stateParams.activity;
        if ($scope.activity) {
            $scope.activity.title = $scope.activity.activityTitle;   // 适配，更新的时候，用的是title
        }

        // 日期类型转换
        $scope.activity.startTime = new Date($scope.activity.startTime);
        $scope.activity.endTime = new Date($scope.activity.endTime);

        $scope.patchActivity = function () {
            var startTime = new Date($scope.activity.startTime).getTime();
            var endTime = new Date($scope.activity.endTime).getTime();
            var now = new Date();
            // now.setHours(0);
            // now.setMinutes(0);
            now.setSeconds(0);
            now.setMilliseconds(0);
            if (startTime > endTime) {
                $ionicPopup.alert(
                    {
                        title: '结束时间应该大于开始时间',
                        okText: '确定'
                    }
                );
            } else {
                uiService.ionicLoadingShow({ templateTitle: '正在更新活动...' });
                $scope.activity.activity_id = $scope.activity.activityId; // TODO 这里有个不一致的地方，临时处理方式。
                // 日期类型转换
                $scope.activity.startTime = new Date($scope.activity.startTime).getTime();
                $scope.activity.endTime = new Date($scope.activity.endTime).getTime();
                apiService.patchActivity($scope.activity, patchActivityCallback);
            }
        }
        $scope.patchActivities = [];
        var patchActivityCallback = {
            onSuccess: function (data, status, config, headers) {
                $ionicPopup.alert(
                    {
                        title: '更新活动',
                        template: '成功',
                        okText: '确定'
                    }
                ).then(function () {
                    // broadcast
                    if ($scope.activity) {
                        $scope.activity.activityTitle = $scope.activity.title;   // 适配，显示的时候，用的是activityTitle
                        $scope.patchActivities = data;
                        fixActivityPreviewPic($scope.patchActivities);
                    }
                    broadcastService.send(
                        broadcastConstants.names.onPatchActivity,
                        {
                            operation: 'patchActivity',
                            result: 'success',
                            activity: $scope.activity,
                        }
                    );
                    $ionicHistory.goBack();
                });
            },
            onError: function (data, status, config, headers) {
                $ionicPopup.alert(
                    {
                        title: '更新活动',
                        template: '失败',
                        okText: '确定'
                    }
                );
            },
            onFinally: function () {
                $ionicLoading.hide();
            }
        }
        function fixActivityPreviewPic(activity) {
            if (activity) {
                if (_.isEmpty(activity.previewPic)) {
                    activity.previewPic = 'img/activity_default.png';
                }
            }
        }
        $ionicTabsDelegate.showBar(false);
    });