angular.module('starter.controllers')

    .controller('ImageUploaderCtrl', function ($scope, $cordovaImagePicker, $cordovaCamera) {

        //
        $scope.pickedImages = [];
        $scope.selectedImages = [];
        $scope.toBeUpdatedRowsImages = [];
        $scope.rowsImages = [];
        var colCount = 3;



        // ---------------------------------------------------------------------------------------------

        $scope.pickImage = function () {
            var options = {
                maximumImagesCount: Number.MAX_VALUE // maximumImagesCount: 10,
                // width: 800,
                // height: 800,
                // quality: 80
            };

            $cordovaImagePicker.getPictures(options)
                .then(function (results) {
                    for (var i = 0; i < results.length; i++) {
                        console.log('Image URI: ' + results[i]);
                    }
                    $scope.selectedImages = results;
                    for (var i = 0; i < images.length; i++) {
                        $scope.toBeUpdatedRowsImages.push(selectedImages[i]);
                    }
                    $scope.rowsImages = oneDimToTwoDimArray($scope.toBeUpdatedRowsImages, colCount);
                }, function (error) {
                    // error getting photos
                });
        }



        // ---------------------------------------------------------------------------------------------
        $scope.capturePictureByCamera = function () {

            var options = {
                destinationType: Camera.DestinationType.FILE_URI,
                sourceType: Camera.PictureSourceType.CAMERA,
                correctOrientation: true,//ios上所拍的图片方向不对
                saveToPhotoAlbum: true
            };

            // var options = {
            //     //这些参数可能要配合着使用，比如选择了sourcetype是0，destinationtype要相应的设置
            //     quality: 100,                                            //相片质量0-100
            //     destinationType: Camera.DestinationType.FILE_URI,        //返回类型：DATA_URL= 0，返回作为 base64 編碼字串。 FILE_URI=1，返回影像档的 URI。NATIVE_URI=2，返回图像本机URI (例如，資產庫)
            //     sourceType: Camera.PictureSourceType.CAMERA,             //从哪里选择图片：PHOTOLIBRARY=0，相机拍照=1，SAVEDPHOTOALBUM=2。0和1其实都是本地图库
            //     allowEdit: false,                                        //在选择之前允许修改截图
            //     encodingType: Camera.EncodingType.JPEG,                   //保存的图片格式： JPEG = 0, PNG = 1
            //     // targetWidth: 200,                                        //照片宽度
            //     // targetHeight: 200,                                       //照片高度
            //     mediaType: 0,                                             //可选媒体类型：圖片=0，只允许选择图片將返回指定DestinationType的参数。 視頻格式=1，允许选择视频，最终返回 FILE_URI。ALLMEDIA= 2，允许所有媒体类型的选择。
            //     cameraDirection: 0,                                       //枪后摄像头类型：Back= 0,Front-facing = 1
            //     popoverOptions: CameraPopoverOptions,
            //     saveToPhotoAlbum: true                                   //保存进手机相册
            // };

            $cordovaCamera.getPicture(options).then(function (imageURI) {
                console.log('Image URI: ' + imageURI);
                $scope.toBeUpdatedRowsImages.push(imageURI);
                $scope.rowsImages = oneDimToTwoDimArray($scope.toBeUpdatedRowsImages, colCount);
            }, function (err) {
                // error
                console.log('Image URI err : ' + imageURI);
            });


            // $cordovaCamera.cleanup(); // only for FILE_URI

        };



        // ---------------------------------------------------------------------------------------------

        // 对数组进行行列设置：1维->2维
        function oneDimToTwoDimArray(arr, colCount) {
            var size = arr.length;
            var rowCount = Math.ceil(size / colCount);
            var rows = [];
            for (var rowIndex = 0; rowIndex < rowCount; rowIndex++) {
                rows[rowIndex] = [];
                for (var colIndex = 0; colIndex < colCount; colIndex++) {
                    var index = rowIndex * colCount + colIndex;
                    if (index < size) {
                        rows[rowIndex][colIndex] = arr[index];
                    } else {
                        break;
                    }
                }
            }
            return rows;
        }
    });
