angular
  .module("starter.controllers")

  .controller(
    "MineChangePwdCtrl",
    function (
      $rootScope,
      $scope,
      $ionicHistory,
      $ionicLoading,
      $http,
      $interval,
      $ionicPopup,
      apiService,
      uiService,
      ngCordovaService
    ) {
      // -----------------------------------------------------------------------------------------
      $scope.data = {
        //
        status: null, // {'telephone_unavailable', 'send_verification_code', 'verify_verification_code', 'change_password'}
        //
        phoneNum: "", // 手机号码
        sendSmsResult: {}, // 发送短信结果
        //
        verifyCode: "", // 验证码
        verifyResult: null, // 验证结果
        //
        oldPwd: "", // 旧密码
        newPwd: "", // 新密码
        newPwd2: "", // 新密码 - check
        changePwdResult: {}, // 更改密码结果
        //
        timeoff: 60, // 短信延时发送
        time_send_sms: null, // 上次发送短信的时间
        remainingTime: 0, // 再次发送短信的剩余时间
      };

      // -----------------------------------------------------------------------------------------
      // telephone phoneNum is unavailable
      $scope.telUnavailable = function () {
        $ionicPopup.alert({
          title: "请到图书馆办理手机号码重置业务",
          okText: "确定",
        });
      };

      // -----------------------------------------------------------------------------------------
      // 上一步
      $scope.goToPrevious = function () {
        if ($scope.data.status == "send_verification_code") {
          // do nothing
        } else if ($scope.data.status == "verify_verification_code") {
          //
          if ($scope.monitorRemainingTimeTask) {
            $interval.cancel($scope.monitorRemainingTimeTask);
            $scope.monitorRemainingTimeTask = null;
          }
          //
          $scope.data.verifyResult = null;
          $scope.data.verifyCode = "";
          $scope.data.sendSmsResult = null;
          //
          $scope.data.status = "send_verification_code";
        } else if ($scope.data.status == "change_password") {
          //
          $scope.data.changePwdResult = null;
          $scope.data.oldPwd = "";
          $scope.data.newPwd = "";
          $scope.data.newPwd2 = "";
          $scope.data.verifyCode = "";
          $scope.data.verifyResult = null;
          $scope.data.sendSmsResult = null;
          //
          $scope.data.status = "verify_verification_code";
        } else {
          // do nothing
        }
      };

      // -----------------------------------------------------------------------------------------
      $scope.monitorRemainingTimeTask = null;
      $scope.getRemainingTime = function () {
        if ($scope.data.time_send_sms) {
          $scope.data.remainingTime =
            $scope.data.timeoff -
            (new Date().getTime() - $scope.data.time_send_sms.getTime()) / 1000;
          if ($scope.data.remainingTime < 0) {
            $scope.data.remainingTime = 0;
          }
        } else {
          $scope.data.remainingTime = 0;
        }
        $scope.data.remainingTime = Math.ceil($scope.data.remainingTime);
        return $scope.data.remainingTime;
      };
      $scope.monitorRemainingTime = function () {
        $scope.monitorRemainingTimeTask = $interval(
          $scope.getRemainingTime,
          1000
        );
        $scope.monitorRemainingTimeTask.then(null, null, function () {
          console.debug("remainingTime:" + $scope.data.remainingTime);
          if ($scope.data.remainingTime <= 0) {
            $interval.cancel($scope.monitorRemainingTimeTask);
            $scope.monitorRemainingTimeTask = null;
          }
        });
      };

      // -----------------------------------------------------------------------------------------
      // 检查手机号码
      $scope.checkAssociatedTelphoneNumber = function () {
        if (
          $scope.user.telephone == null ||
          $scope.user.telephone.length == 0
        ) {
          $scope.data.status = "telephone_unavailable";
        } else {
          $scope.data.phoneNum = $scope.user.telephone;
          $scope.data.status = "send_verification_code";
        }
      };

      // -----------------------------------------------------------------------------------------
      // 发送短信验证码
      $scope.sendSmsVerificationCodeForChangePassword = function () {
        // TODO check phoneNum format
        //
        uiService.ionicLoadingShow({ templateTitle: "正在发送验证码..." });
        $scope.data.time_send_sms = new Date();
        apiService.sendSmsVerificationCodeForChangePassword(
          $scope.data.phoneNum,
          sendSmsVerificationCodeForChangePasswordCallback
        );
      };
      var sendSmsVerificationCodeForChangePasswordCallback = {
        onSuccess: function (data, status, config, headers) {
          // data.status: 'success', 'failed'
          $scope.data.sendSmsResult = data;
          if (data.status == "OK") {
            $scope.data.status = "verify_verification_code";
          } else {
            ngCordovaService.showToast(data.data);
          }

          $scope.monitorRemainingTime();
        },
        onError: function (data, status, hedaers, config) {
          console.warn("无法发送验证码");
        },
        onFinally: function () {
          $ionicLoading.hide();
        },
      };

      // -----------------------------------------------------------------------------------------
      //
      $scope.verifySmsVerificationCode = function () {
        // TODO check verification code format
        //
        uiService.ionicLoadingShow({ templateTitle: "正在验证..." });
        apiService.verifySmsVerificationCode(
          $scope.user.account,
          $scope.data.verifyCode,
          verifySmsVerificationCodeCallback
        );
      };
      var verifySmsVerificationCodeCallback = {
        onSuccess: function (data, status, config, headers) {
          // data: true, false
          $scope.data.verifyResult = data;
          if (data == true) {
            $scope.data.status = "change_password";
            console.log("验证码验证通过");
          } else {
            console.warn("验证码错误");
            ngCordovaService.showToast("验证码错误");
          }
        },
        onError: function (data, status, hedaers, config) {
          console.warn("验证验证码：未知错误");
          // ngCordovaService.showToast('验证验证码：未知错误');
        },
        onFinally: function () {
          $ionicLoading.hide();
        },
      };

      // -----------------------------------------------------------------------------------------
      // 修改登录密码
      $scope.changeReaderPassword = function () {
        // TODO check 2 new password whether same
        //
        uiService.ionicLoadingShow({ templateTitle: "正在修改密码..." });
        var pwdInfo = {
          account: $scope.user.account,
          oldPassword: $scope.data.oldPwd,
          newPassword: $scope.data.newPwd,
        };
        apiService.changeReaderPassword(pwdInfo, changeReaderPasswordCallback);
      };
      var changeReaderPasswordCallback = {
        onSuccess: function (data, status, config, headers) {
          // data.status: 'success', 'failed'
          $scope.data.changePwdResult = data;
          if (data.status) {
            console.log("您已成功修改密码：" + data.message);
            ngCordovaService.showToast("您已成功修改密码");
            $ionicHistory.goBack();
          } else {
            console.log("您已成功修改密码：" + data.message);
            // ngCordovaService.showToast('修改密码失败');
          }
        },
        onError: function (data, status, hedaers, config) {
          console.warn("修改密码：未知错误");
          // ngCordovaService.showToast('修改密码：未知错误');
        },
        onFinally: function () {
          $ionicLoading.hide();
        },
      };

      // -----------------------------------------------------------------------------------------
      //
      // $scope.user.telephone = ''; // TODO: to hardcode if telep is unavailable
      $scope.checkAssociatedTelphoneNumber();

      // -----------------------------------------------------------------------------------------
      //
      // $ionicTabsDelegate.showBar(true);
    }
  );
