angular
  .module("starter.controllers")

  .controller(
    "reserveCtrl",
    function (
      $compile,
      $rootScope,
      $scope,
      $ionicHistory,
      $ionicSlideBoxDelegate,
      $state,
      apiService,
      uiService,
      $ionicLoading,
      $ionicTabsDelegate,
      broadcastService,
      broadcastConstants,
      ngCordovaService,
      $ionicPopup
    ) {
      if (!$scope.user) {
        $state.go("tab.mine", { fromState: $ionicHistory.currentStateName() });
        return;
      }
      $scope.limitBooks = $rootScope.allowBorrowCount;
      $scope.tabNames = ["当前预约", "历史预约"];
      $scope.slectIndex = 0;
      $scope.activeSlide = function (index) {
        //点击时候触发
        $scope.slectIndex = index;
        $ionicSlideBoxDelegate.slide(index);
      };
      $scope.slideChanged = function (index) {
        //滑动时候触发
        $scope.slectIndex = index;
      };
      $scope.flag = false;
      $scope.desc = true;
      $scope.pages = [
        "modules/mine/nowReserve.html",
        "modules/mine/historyReserve.html",
      ];

      $scope.statusMap = {
        borrowing: "预约中",
        borrowed: "预约成功",
        borrowFailed: "预约失败",
        autoReturnedByCancelReserve: "预约取消归还",
        autoReturnedByReserveUnpick: "预约未取归还",
      };
      // 消息
      $scope.refreshFailed = false;
      $scope.refreshFailedMsg = "刷新失败，下拉重新刷新";
      $scope.refreshSuccessful = false;
      $scope.loadMoreFailed = false;
      $scope.loadMoreFailedMsg = "加载更多失败，上拉重新加载";
      //
      $scope.curPage = -1;
      $scope.pageSize = 4;
      $scope.totalPages = 0;
      $scope.elementsCount = 0;
      $scope.moreDataCanBeLoaded = false;
      //下拉刷新
      $scope.refresh = function () {
        // reset
        $scope.curPage = -1;
        $scope.refreshSuccessful = false;
        $scope.moreDataCanBeLoaded = false;
        //
        apiService.getReserveBook(
          $scope.curPage + 1,
          $scope.pageSize,
          $rootScope.user.borrowID,
          {
            onSuccess: onRefreshSuccess,
            onError: onRefreshError,
          }
        );
      };
      //加载更多
      $scope.loadMore = function () {
        if (!$scope.refreshSuccessful) {
          $scope.$broadcast("scroll.infiniteScrollComplete");
          return;
        }
        apiService.getReserveBook(
          $scope.curPage + 1,
          $scope.pageSize,
          $rootScope.user.borrowID,
          {
            onSuccess: onLoadMoreSuccess,
            onError: onLoadMoreError,
          }
        );
      };
      // 刷新和加载更多的事件监听器
      function onRefreshSuccess(data) {
        console.log("onRefreshSuccess");
        var books = data.data;
        console.log(books);
        $scope.books = books;
        //一本图书没有时，显示提示
        if ($scope.books.length == 0) {
          $scope.flag = false;
        } else {
          $scope.flag = true;
        }
        $scope.elementsCount = data.elementsCount;
        $scope.totalPages = data.totalPages;
        //
        if ($scope.books.length < $scope.elementsCount) {
          $scope.moreDataCanBeLoaded = true;
        } else {
          $scope.moreDataCanBeLoaded = false;
        }
        $scope.curPage = $scope.curPage + 1;
        $scope.refreshFailed = false;
        $scope.refreshSuccessful = true;
        // 发送广播
        $scope.$broadcast("scroll.refreshComplete");
      }
      function onRefreshError() {
        console.log("onRefreshError");
        $scope.refreshFailed = true;
        // 发送广播
        $scope.$broadcast("scroll.refreshComplete");
      }
      function onLoadMoreSuccess(data) {
        console.log("onLoadMoreSuccess");
        var books = data.data;
        if ($scope.books) {
          for (var i = 0; i < books.length; i++) {
            $scope.books.push(books[i]);
          }
        }
        $scope.elementsCount = data.elementsCount;
        $scope.totalPages = data.totalPages;
        //
        if ($scope.books.length < $scope.elementsCount) {
          $scope.moreDataCanBeLoaded = true;
        } else {
          $scope.moreDataCanBeLoaded = false;
        }
        //
        $scope.curPage = $scope.curPage + 1;
        $scope.loadMoreFailed = false;
        // 发送广播
        $scope.$broadcast("scroll.infiniteScrollComplete");
      }
      function onLoadMoreError() {
        console.log("onLoadMoreError");
        $scope.loadMoreFailed = true;
        // 发送广播
        $scope.$broadcast("scroll.refreshComplete");
      }
      //单选
      $scope.showBorrow = true;
      $scope.showDelete = true;
      $scope.checked = [];
      $scope.ifBorrow = [];
      $scope.selectOne = function (book) {
        var index = $scope.checked.indexOf(book.id);
        if (book.checked && index === -1) {
          $scope.checked.push(book.id);
          $scope.ifBorrow.push(book);
        } else if (!book.checked && index !== -1) {
          $scope.checked.splice(index, 1);
          $scope.ifBorrow.splice(index, 1);
        }
        if ($scope.ifBorrow.length == 0) {
          $scope.showBorrow = true;
          $scope.showDelete = true;
        }
        for (var i = 0; i < $scope.ifBorrow.length; i++) {
          // if ($scope.ifBorrow.length == 0) {
          //     $scope.showBorrow = true;
          //     $scope.showDelete = true;
          //     return;
          // } else {
          $scope.showDelete = false;
          if ($scope.ifBorrow[i].loanedStatus == false) {
            $scope.showBorrow = true;
            return;
          } else {
            $scope.showBorrow = false;
          }
          // }
        }
      };
      // //刪除
      $scope.deletebooks = function () {
        if ($scope.checked.length == 0) {
          ngCordovaService.showToast("请选择你要刪除的图书");
        } else if ($scope.checked.length >= 1) {
          $ionicPopup
            .confirm({
              title: "取消预约",
              template: "確定要取消预约吗？",
              cancelText: "取消",
              okText: "确定",
            })
            .then(function (res) {
              if (res) {
                var reserveItemIds = angular.toJson($scope.checked);
                uiService.ionicLoadingShow({
                  templateTitle: "正在删除所选图书...",
                });
                apiService.deleteReserve(
                  $rootScope.user.borrowID,
                  reserveItemIds,
                  deleteReserveCallback
                );
              }
            });
        }
      };
      var deleteReserveCallback = {
        onSuccess: function (data, status, config, headers) {
          ngCordovaService.showToast("删除所选图书成功");
          $scope.checked = [];
          $scope.ifBorrow = [];
          $scope.showBorrow = true;
          $scope.showDelete = true;
        },
        onError: function (data, status, config, headers) {
          ngCordovaService.showToast("删除所选图书失败");
        },
        onFinally: function () {
          // 隐藏进度条
          $ionicLoading.hide();

          $scope.refresh();
        },
      };
      //借阅
      $scope.goAddress = function () {
        if ($scope.checked.length == 0) {
          ngCordovaService.showToast("请选择你要借阅的图书");
        } else if ($scope.checked.length >= 6) {
          $ionicPopup.alert({
            title: "一次最多可借5本书",
            okText: "确定",
          });
        } else {
          if ($scope.checked.length >= $scope.limitBooks) {
            $ionicPopup.alert({
              title:
                "对不起，该卡最多只能借" +
                $scope.limitBooks +
                "本书，请将其他图书归还后再借阅该图书",
              okText: "确定",
            });
          } else {
            var bookIdJson = angular.toJson($scope.checked);
            $scope.currentState = $ionicHistory.currentStateName();
            if ($scope.currentState == "tab.homeminereserve") {
              $state.go("tab.homeorderconfirm", {
                book: $scope.checked,
                bookIdJson: bookIdJson,
              });
            } else {
              $state.go("tab.orderconfirm", {
                book: $scope.checked,
                bookIdJson: bookIdJson,
              });
            }
          }
        }
      };

      //历史预约
      //---------------------------------------------------------------------------------------//
      // 消息
      $scope.refreshFailedHistory = false;
      $scope.refreshFailedMsgHistory = "刷新失败，下拉重新刷新";
      $scope.refreshSuccessfulHistory = false;
      $scope.loadMoreFailedHistory = false;
      $scope.loadMoreFailedMsgHistory = "加载更多失败，上拉重新加载";
      //
      $scope.curPageHistory = -1;
      $scope.pageSizeHistory = 4;
      $scope.totalPagesHistory = 0;
      $scope.elementsCountHistory = 0;
      $scope.moreDataCanBeLoadedHistory = false;
      $scope.refreshHistory = function () {
        // reset
        $scope.curPageHistory = -1;
        $scope.refreshSuccessfulHistory = false;
        $scope.moreDataCanBeLoadedHistory = false;
        //
        apiService.historyReserve(
          $scope.curPageHistory + 1,
          $scope.pageSizeHistory,
          $rootScope.user.borrowID,
          {
            onSuccess: onRefreshSuccessHistory,
            onError: onRefreshErrorHistory,
          }
        );
      };
      $scope.loadMoreHistory = function () {
        if (!$scope.refreshSuccessfulHistory) {
          $scope.$broadcast("scroll.infiniteScrollComplete");
          return;
        }
        apiService.historyReserve(
          $scope.curPageHistory + 1,
          $scope.pageSizeHistory,
          $rootScope.user.borrowID,
          {
            onSuccess: onLoadMoreSuccessHistory,
            onError: onLoadMoreErrorHistory,
          }
        );
      };
      // 刷新和加载更多的事件监听器
      function onRefreshSuccessHistory(data) {
        console.log("onRefreshSuccess");
        var booksHistory = data.data;
        console.log(booksHistory);
        $scope.booksHistory = booksHistory;
        $scope.elementsCountHistory = data.elementsCount;
        $scope.totalPagesHistory = data.totalPages;
        //
        if ($scope.booksHistory.length < $scope.elementsCountHistory) {
          $scope.moreDataCanBeLoadedHistory = true;
        } else {
          $scope.moreDataCanBeLoadedHistory = false;
        }
        $scope.curPageHistory = $scope.curPageHistory + 1;
        $scope.refreshFailedHistory = false;
        $scope.refreshSuccessfulHistory = true;
        // 发送广播
        $scope.$broadcast("scroll.refreshComplete");
      }
      function onRefreshErrorHistory() {
        console.log("onRefreshError");
        $scope.refreshFailedHistory = true;
        // 发送广播
        $scope.$broadcast("scroll.refreshComplete");
      }
      function onLoadMoreSuccessHistory(data) {
        console.log("onLoadMoreSuccessHistory");
        var booksHistory = data.data;
        if ($scope.booksHistory) {
          for (var i = 0; i < booksHistory.length; i++) {
            $scope.booksHistory.push(booksHistory[i]);
          }
        } else {
          $scope.booksHistory = books;
        }
        $scope.elementsCountHistory = data.elementsCount;
        $scope.totalPagesHistory = data.totalPages;
        //
        if ($scope.booksHistory.length < $scope.elementsCountHistory) {
          $scope.moreDataCanBeLoadedHistory = true;
        } else {
          $scope.moreDataCanBeLoadedHistory = false;
        }
        //
        $scope.curPageHistory = $scope.curPageHistory + 1;
        $scope.loadMoreFailedHistory = false;
        // 发送广播
        $scope.$broadcast("scroll.infiniteScrollComplete");
      }
      function onLoadMoreErrorHistory() {
        console.log("onLoadMoreErrorHistory");
        $scope.loadMoreFailedHistory = true;
        // 发送广播
        $scope.$broadcast("scroll.refreshComplete");
      }

      $scope.refresh();
      $scope.refreshHistory();
      $ionicTabsDelegate.showBar(false);
    }
  );
