angular.module('starter.controllers')

    .controller('MineChildrenController', function ($scope, $state, $stateParams, $ionicTabsDelegate, $ionicModal, apiService, uiService, ngCordovaService, $ionicLoading, $ionicPopup) {

        //
        $scope.children = [];


        // -----------------------------------------------------------------------------------------
        $scope.queryChildrenInfoAll = function () {
            uiService.ionicLoadingShow({ templateTitle: '正在查询...' });
            apiService.queryChildrenInfoAll($scope.user.account, queryChildrenInfoAllCallback);
        };
        var queryChildrenInfoAllCallback = {
            onSuccess: function (data, status, config, headers) {
                console.log('queryChildrenInfoAllCallback. onSuccess');
                $scope.children = data;
            },
            onError: function (data, status, config, headers) {
                console.warn('queryChildrenInfoAllCallback. onError');
            },
            onFinally: function () {
                // 隐藏进度条
                $ionicLoading.hide().then(function () {
                    console.log("The loading indicator is now hidden");
                });
            }
        };

        // -----------------------------------------------------------------------------------------
        $scope.addChildInfo = function (child) {
            uiService.ionicLoadingShow({ templateTitle: '正在删除...' });
            apiService.addChildInfo(child, addChildInfoCallback);
        }
        var addChildInfoCallback = {
            onSuccess: function (data, status, config, headers) {
                ngCordovaService.showToast('添加成功');
                $scope.queryChildrenInfoAll();
                $scope.modal.hide();
            },
            onError: function (data, status, config, headers) {
                ngCordovaService.showToast('添加失败');
            },
            onFinally: function () {
                // 隐藏进度条
                $ionicLoading.hide().then(function () {
                    console.log("The loading indicator is now hidden");
                });
            }
        };

        // -----------------------------------------------------------------------------------------
        $scope.deleteChildInfo = function (child) {
            uiService.ionicLoadingShow({ templateTitle: '正在删除...' });
            apiService.deleteChildInfo(child.id, deleteChildInfoCallback);
        }
        var deleteChildInfoCallback = {
            onSuccess: function (data, status, config, headers) {
                ngCordovaService.showToast('删除成功');
                $scope.queryChildrenInfoAll();
                $scope.modal.hide();
            },
            onError: function (data, status, config, headers) {
                ngCordovaService.showToast('删除失败');
            },
            onFinally: function () {
                // 隐藏进度条
                $ionicLoading.hide().then(function () {
                    console.log("The loading indicator is now hidden");
                });
            }
        };

        // -----------------------------------------------------------------------------------------
        $scope.updateChildInfo = function (child) {
            uiService.ionicLoadingShow({ templateTitle: '正在删除...' });
            apiService.updateChildInfo(child, updateChildInfoCallback);
        }
        var updateChildInfoCallback = {
            onSuccess: function (data, status, config, headers) {
                ngCordovaService.showToast('更新成功');
                $scope.queryChildrenInfoAll();
                $scope.modal.hide();
            },
            onError: function (data, status, config, headers) {
                ngCordovaService.showToast('更新失败');
            },
            onFinally: function () {
                // 隐藏进度条
                $ionicLoading.hide().then(function () {
                    console.log("The loading indicator is now hidden");
                });
            }
        };


        // -----------------------------------------------------------------------------------------
        $ionicModal.fromTemplateUrl('modules/mine/childInfo.html', {
            scope: $scope
        }).then(function (modal) {
            $scope.modal = modal;
        });
        $scope.goChildInfo = function (operation, child) {
            $scope.modal_data = undefined;
            switch (operation) {
                case 'add':
                    $scope.modal_data = {
                        title: '添加',
                        operationText: '保存',
                        child: { userId: $scope.user.account },
                        operation: function () { $scope.addChildInfo($scope.modal_data.child) },
                    };
                    break;
                case 'edit':
                    $scope.modal_data = {
                        title: '编辑',
                        operationText: '保存设置',
                        child: angular.copy(child),
                        operation: function () { $scope.updateChildInfo($scope.modal_data.child) },
                    };
                    break;
                case 'delete':
                    $scope.modal_data = {
                        title: '删除',
                        operationText: '删除',
                        child: angular.copy(child),
                        operation: function () { $scope.deleteChildInfo($scope.modal_data.child) },
                    };
                    break;
                default:
                    break;
            }
            if ($scope.modal_data) {
                $scope.modal.show();
            }
        };


        //
        $scope.showAddUser = function () {
            $scope.goChildInfo('add');
        };
        $scope.deleteChild = function (child) {
            $scope.deleteChildInfo(child);
        };


        //
        $ionicTabsDelegate.showBar(false);
        //
        $scope.queryChildrenInfoAll();

    });