angular
  .module("starter.controllers")

  .controller(
    "SettingsCtrl",
    function (
      $rootScope,
      $scope,
      $state,
      $ionicPopup,
      apiService,
      ngCordovaService,
      $ionicHistory,
      appService,
      $ionicTabsDelegate
    ) {
      //
      $scope.logout = function () {
        apiService.userLogout(logoutCallback);
      };
      var logoutCallback = {
        onSuccess: function (data, status, config, headers) {
          var params = {
            sequence: $rootScope.sequence,
          };
          window.plugins.jPushPlugin.deleteAlias(
            params,
            function (msg) {
              console.log(msg);
            },
            function (msg) {
              console.log(msg);
            }
          );
          window.plugins.jPushPlugin.cleanTags(
            params,
            function (msg) {
              console.log(msg);
            },
            function (msg) {
              console.log(msg);
            }
          );
        },
        onError: function (data, status, hedaers, config) {},
        onFinally: function () {
          //
          if ($rootScope.refreshTokenTimer) {
            clearInterval($rootScope.refreshTokenTimer);
          }
          $rootScope.user = null;
          // remove login info
          // localStorage.removeItem('loginInfo_account'); // 为了下一次登录方便，暂不清除该信息。
          localStorage.removeItem("loginInfo_password");
          localStorage.removeItem("reader_info");
          localStorage.removeItem("access_token");
          localStorage.removeItem("refresh_token");
          // 清除用户信息
          $rootScope.userInfo = null;
          // 恢复默认的馆藏信息
          //
          $state.go("tab.mine");
        },
      };

      // 修改手机号码
      $scope.changePhoneNumber = function () {
        $ionicPopup.alert({
          title: "请到图书馆办理手机号码重置业务",
          okText: "确定",
        });
      };
      $scope.goMineAddress = function () {
        $ionicHistory.clearCache().then(function () {
          $state.go("tab.mine_address");
        });
      };
      $scope.goVersion = function () {
        $state.go("tab.mine_version");
      };
      $scope.goUnbound = function () {
        $state.go("tab.unboundFace");
      };
      // ------------------------------------------------------------------------------------------------------------
      //
      $ionicTabsDelegate.showBar(false);
    }
  );
