angular
  .module("starter.controllers")

  .controller(
    "UploadFaceCtrl",
    function (
      $scope,
      $ionicTabsDelegate,
      $rootScope,
      $cordovaCamera,
      uiService,
      $ionicLoading,
      ngCordovaService,
      $cordovaFileTransfer
    ) {
      $ionicTabsDelegate.showBar(false);
      $scope.identity = {
        data: null,
      };
      $scope.capturePictureByCamera = function () {
        var options = {
          destinationType: Camera.DestinationType.FILE_URI,
          sourceType: Camera.PictureSourceType.CAMERA,
          correctOrientation: true, //ios上所拍的图片方向不对
          saveToPhotoAlbum: true,
          targetWidth: 600,
          targetHeight: 800,
          quality: 80,
        };

        $cordovaCamera.getPicture(options).then(
          function (imageURI) {
            console.log("capturePictureByCamera. Image URI: " + imageURI);
            $scope.faceImgUrl = imageURI;
          },
          function (err) {
            // error
            console.log("capturePictureByCamera. Image URI err : " + err);
          }
        );
      };
      $scope.uploadNewAvator = function () {
        console.log($scope.identity.data);
        if (!$scope.faceImgUrl) {
          ngCordovaService.showToast("请先上传人脸照片！");
          return;
        }
        if (!_.isEmpty($scope.identity.data)) {
          var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
          if (reg.test($scope.identity.data) === false) {
            ngCordovaService.showToast("身份证输入不合法");
            return;
          }
        }

        uiService.ionicLoadingShow({ templateTitle: "正在上传验证..." });
        var server =
          bookroomBaseUrl +
          "/bookroom_api/reader_face/check_upload_face_and_name/" +
          $rootScope.user.account +
          "?name=" +
          $rootScope.user.name +
          "&faceSource=app&identity=" +
          $scope.identity.data;
        var filePath = $scope.faceImgUrl;
        var options = null;
        $cordovaFileTransfer.upload(server, filePath, options).then(
          function (result) {
            // Success!
            $ionicLoading.hide();
            ngCordovaService.showToast(angular.fromJson(result.response).data);
          },
          function (err) {
            // Error
            $ionicLoading.hide();
            ngCordovaService.showToast("服务器连接失败，请稍后尝试");
          }
        );
      };
    }
  );
